Codeforces Round #790 (Div. 4) E. Eating Queries

Codeforces Round #790 (Div. 4) E. Eating Queries

Let’s solve the problem with just one query. Greedily, we should pick the candies with the most sugar first, since there is no benefit to picking a candy with less sugar.

So the solution is as follows: sort the candies in descending order, and then find the prefix whose sum is ≥ x ≥x x. This is O ( n ) O(n) O(n) per query, which is too slow for us.

To speed it up, notice that we just need to find a prefix sum at least x x x. So if we compute the prefix sums of the reverse-sorted array, we need to find the first element that is at least x x x.

Since all elements of a a a are positive, the array of prefix sums is increasing. Therefore, you can binary search the first element ≥ x ≥x x. This solves the problem in l o g n logn logn per query.

Total time complexity: O ( q l o g n + n ) O(qlogn+n) O(qlogn+n).

  • 一个简单的二分排序然后通过前缀和二分查找
#include<bits/stdc++.h>
using namespace std;

signed main()
{
    int T;cin>>T;
    while(T--)
    {
        int n,q;cin>>n>>q;
        vector<int> a(n);
        for(int i=0;i<n;i++) cin>>a[i];
        sort(a.begin(),a.end(),greater<int>());
        for(int i=1;i<n;i++) a[i]+=a[i-1];
        for(int i=0;i<q;i++)
        {
            int x;cin>>x;
            if(x>a[n-1]) cout<<"-1"<<endl;
            else
            {
                int pos=lower_bound(a.begin(),a.end(),x)-a.begin();
                cout<<pos+1<<endl;
            }
        }
    }
    return 0;
}
  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 打赏
    打赏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包

打赏作者

Wa_Automata

你的鼓励将是我创作的最大动力

¥1 ¥2 ¥4 ¥6 ¥10 ¥20
扫码支付:¥1
获取中
扫码支付

您的余额不足,请更换扫码支付或充值

打赏作者

实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值